{&CDecl+}
library dsp_split;

uses
     VPUtils,

     Windows;

type
      PSamples = ^TSamples;
      TSamples = array[0..0] of SmallInt;

      PModule = ^TModule;
      TModule = record
       Description: PChar;
       Parent: HWND;
       Instance: HINST;
       Config: procedure(Module: PModule);
       Init: function(Module: PModule): Integer;
       Modify: function(Module: PModule; Samples: PSamples; Count, bps, Channels, Rate: Integer): Integer;
       Quit: procedure(Module: PModule);
       UserData: Pointer;
      end;

      PHeader = ^THeader;
      THeader = record
       Version: Integer;
       Description: PChar;
       GetModule: function(Module: Integer): PModule;
      end;

procedure Config(Module: PModule); forward;
function Init(Module: PModule): Integer; forward;
function ModifyOnlyLeft(Module: PModule; Samples: PSamples; Count, bps, Channels, Rate: Integer): Integer; forward;
function ModifyOnlyRight(Module: PModule; Samples: PSamples; Count, bps, Channels, Rate: Integer): Integer; forward;
procedure Quit(Module: PModule); forward;
function GetModule(Module: Integer): PModule; forward;

const
 HeaderVersion          = $20;

 OnlyLeft: TModule =
       (Description     : 'Stereo -> left channel';
        Parent          : 0;
        Instance        : 0;
        Config          : Config;
        Init            : Init;
        Modify          : ModifyOnlyLeft;
        Quit            : Quit);

 OnlyRight: TModule =
       (Description     : 'Stereo -> right channel';
        Parent          : 0;
        Instance        : 0;
        Config          : Config;
        Init            : Init;
        Modify          : ModifyOnlyRight;
        Quit            : Quit);

 Header: THeader =
       (Version         : HeaderVersion;
        Description     : 'Split';
        GetModule       : GetModule
       );

procedure Config(Module: PModule);
 begin
  MessageBox(0, 'Split'#13'(q) by sk // [rAN], 2000.'#13'mailto:skank@mail.ru'#13'http://www.irnet.ru/sk', 'Split', mb_ok or mb_iconinformation);
 end;

function Init(Module: PModule): Integer;
 begin
  Result:=0;
 end;

function ModifyOnlyLeft(Module: PModule; Samples: PSamples; Count, bps, Channels, Rate: Integer): Integer;
 var
  K: Integer;
 begin
  if Channels = 2 then
   for K:=0 to Count - 1 do
    begin
     Samples^[K * 2]:=(Samples^[K * 2] + Samples^[K * 2 + 1]) div 2;

     Samples^[K * 2 + 1]:=0;
    end;

  ModifyOnlyLeft:=Count;
 end;

function ModifyOnlyRight(Module: PModule; Samples: PSamples; Count, bps, Channels, Rate: Integer): Integer;
 var
  K: Integer;
 begin
  if Channels = 2 then
   for K:=0 to Count - 1 do
    begin
     Samples^[K * 2 + 1]:=(Samples^[K * 2] + Samples^[K * 2 + 1]) div 2;

     Samples^[K * 2]:=0;
    end;

  ModifyOnlyRight:=Count;
 end;

procedure Quit(Module: PModule);
 begin
 end;

function GetModule(Module: Integer): PModule;
 begin
  case Module of
   0: Result:=@OnlyLeft;
   1: Result:=@OnlyRight;
  else
   Result:=nil;
  end;
 end;

function winampDSPGetHeader2: PHeader; cdecl;
 begin
  Result:=@Header;
 end;

exports
 winampDSPGetHeader2;

begin
end.
